/* tde18r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Builtin functions */
    double sqrt(double), sin(double), cos(double);

    /* Local variables */
    extern int de18r_c(U_fp, int *, int *, float *, float *, float *,
                       float *, float *, float *, float *, float *, float *,
                       float *, float *, float *, float *, float *, int *);
    static float hmin;
    static int ierr;
    extern int f_c();
    static float h__;
    static int i__, m;
    static float p, x, y[2], delty[2], y1, y2, df[10] /* was [2][5] */,
               rf[2], dy[2], xn, yn[2];
    static int iorder;
    static float rfn[2], eps, dyn[2];

#define df_ref(a_1,a_2) df[(a_2)*2 + a_1 - 3]

    h__ = .01f;
    iorder = 5;
    p = 100.f;
    eps = 1e-4f;
    hmin = 1e-10f;
    m = 2;
    xn = 2.3561944901925003f;
    yn[0] = (float)sqrt(2.f) / 2.f;
    yn[1] = -yn[0];
    dyn[0] = yn[1];
    dyn[1] = -yn[0];
    de18r_c((U_fp)f_c, &m, &iorder, &xn, yn, dyn, &hmin, &eps, &p, &h__, &x,
            y, dy, df, rfn, rf, delty, &ierr);
    y1 = (float)sin(x);
    y2 = (float)cos(x);

    printf("\n %16.7e \n", x);
    printf("\n %16.7e %16.7e \n", y[0], y[1]);
    printf("\n %16.7e %16.7e \n", dy[0], dy[1]);
    printf("\n %16.7e %16.7e \n", y1, y2);
    for (i__ = 1; i__ <= 2; ++i__) {
    printf("\n %16.7e %16.7e %16.7e \n",
           df_ref(i__, 1), df_ref(i__, 2), df_ref(i__, 3));
    printf(" %16.7e %16.7e \n",
           df_ref(i__, 4), df_ref(i__, 5));
    }
    return 0;
} /* main */

#undef df_ref

int f_c(float *t, float *y, float *z__, int *m)
{
    /* Parameter adjustments */
    --z__;
    --y;

    /* Function Body */
    z__[1] = -y[1];
    z__[2] = -y[2];
    return 0;
} /* f_c */
